/*************************************************************************
 *
 * HTCd - Copyright (C) 1998-2006 Henrik Rydberg
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <lang/env.h>

void envAddOps(opmap& M,tokmap& T);
void envAddBasic(tokmap& T);
void envAddFunc(tokmap& T);
void envAddFlow(tokmap& T);
void envAddDB(tokmap& T);
void envAddLatex(tokmap& T);
void envAddHelp(tokmap& T);

Lang::Lang() : running(1)
{
  envAddOps(ops,toks);
  envAddBasic(toks);
  envAddFunc(toks);
  envAddFlow(toks);
  envAddDB(toks);
  envAddLatex(toks);
  envAddHelp(toks);
}
