/*************************************************************************
 *
 * HTCd - Copyright (C) 1998-2006 Henrik Rydberg
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef RANDOMH
#define RANDOMH

#include <mt/qran.h>

///////////////////////////////////////////////////////////////////
//
// Uniform distribution ]x0..x1[
//
// Granularity approx 1.2e-7, ie more than 1e6 different values
// Perodicity approx 1e8
//

unsigned long RandomInit(unsigned long seed);

float Uniform();
float Exponential();
float Gaussian();

#endif
