/*************************************************************************
 *
 * HTCd - Copyright (C) 1998-2006 Henrik Rydberg
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef BUFFERH
#define BUFFERH

#include <mt/mstring.h>
#include <time.h>

inline void LoadBuffer(mstring& buffer,const mstring& path)
  throw(merror_t)
{
  if(buffer.load(path.c_str())<0) THROW("file: Could not load "<<path);
}

inline void SaveBuffer(const sref& buffer,const mstring& path,int prot=0600)
  throw(merror_t)
{
  if(buffer.save(path,prot)<0) THROW("file: Could not save "<<path);
}

#endif
