/*************************************************************************
 *
 * HTCd - Copyright (C) 1998-2006 Henrik Rydberg
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef ENCMIMEH
#define ENCMIMEH

#include <mime/pack.h>

const mstring trans_base64="base64";
const mstring trans_quote="quoted-printable";
const mstring mime_default="iso-8859-1";

void decode64(mstream& out,const sref& in);
void encode64(mstream& out,const sref& in);
void decodeQP(mstream& out,const sref& in);
void encodeQP(mstream& out,const sref& in);
void decodeHeader(mstream& out,mstring& mime,const sref& in);
void encodeHeader(mstream& out,const sref& mime,const sref& in);

#endif
