/*************************************************************************
 *
 * HTCd - Copyright (C) 1998-2006 Henrik Rydberg
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef PACKH
#define PACKH

#include <mt/mset.h>
#include <mt/msmap.h>

// Really mimefunctions, but needed here

mstream& cashex(mstream& out,unsigned char c);
char hexasc(unsigned char c1,unsigned char c2);

// Packing means application/x-www-form-urlencoded

void Unpack(mstream& out,const sref& in);
void Unpack(spile& list,const sref& in);
void Unpack(sspile& list,const sref& in);

void Pack(mstream& out,const sref& in);
void Pack(mstream& out,const rpile& list);
void Pack(mstream& out,const rrpile& list);

// CR LF and CRLF business

const mstring CRLF="\r\n";

void CRLF2LF(mstream& out,const sref& in);
void LF2CRLF(mstream& out,const sref& in);

#endif
